%{?!with_gpm:		%global with_gpm 0}
%{?!without_xterm_new:	%global without_xterm_new 0}
%global momorel 4

Summary: A CRT screen handling and optimization package.
Name: ncurses
Version: 5.4
%define includedirw %{_includedir}/ncursesw
Release: %{momorel}m
License: GPL
Group: System Environment/Libraries
URL: http://dickey.his.com/ncurses/ncurses.html
%NoSource 0 ftp://dickey.his.com/%{name}/%{name}-%{version}.tar.gz 069c8880072060373290a4fefff43520
Source1: patch-5.4-20050319.sh
Source2: ncurses-linux
Source3: ncurses-linux-m
Source4: ncurses-resetall.sh
#Source5: term.sh
Source100: terminfo.jfbterm
Source101: terminfo.kon
Patch1: ncurses-5.4-20050320.patch
Patch2: ncurses-5.4-20050326.patch
Patch3: ncurses-5.4-20050327.patch
BuildPreReq: coreutils, sharutils
PreReq: coreutils
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%ifarch ia64 x86_64 ppc64 s390x
Obsoletes: elf32(%{name})
%else
Provides: elf32(%{name})
%endif

%description
The curses library routines are a terminal-independent method of
updating character screens with reasonable optimization.  The ncurses
(new curses) library is a freely distributable replacement for the
discontinued 4.4 BSD classic curses library.

%package devel
Summary: The development files for applications that use ncurses.
Group: Development/Libraries
Requires: ncurses = %{PACKAGE_VERSION}
%ifarch ia64 x86_64 ppc64 s390x
Obsoletes: elf32(%{name})
%else
Provides: elf32(%{name})
%endif


%description devel
The header files and libraries for developing applications that use
the ncurses CRT screen handling and optimization package.

Install the ncurses-devel package if you want to develop applications
which will use ncurses.

Use the following compiler flags to build against the ncurses library:

-lncurses
(compile and link against the regular ncurses library)

-I %{includedirw} -lncursesw
(compile and link against the wide-character, UTF-8, library)

%package c++-devel
Summary: C++ bindings to ncurses
Group: System Environment/Libraries
Requires: ncurses = %{PACKAGE_VERSION}
Requires: ncurses-devel = %{PACKAGE_VERSION}

%description c++-devel
C++ bindings to ncurses

%prep
%setup -q

/bin/bash %{SOURCE1}

%patch1  -p1 -b .20050320
%patch2  -p1 -b .20050326
%patch3  -p1 -b .20050327

cat %{SOURCE100} %{SOURCE101} >> misc/terminfo.src

%build
CFLAGS="%{optflags} -DPURE_TERMINFO -DSVR4_CURSES"
%define optflags $CFLAGS

%if %{with_gpm}
WITH_GPM="--with-gpm"
%endif

%if %{without_xterm_new}
WITHOUT_XTERM_NEW="--without-xterm-new"
%endif

mkdir narrowc widec
cd narrowc
ln -s ../configure .
%configure --with-shared --with-cxx --without-ada --with-ospeed=unsigned \
   $WITH_GPM --enable-sigwinch --enable-hard-tabs --enable-xmc-glitch \
   --enable-colorfgbg $WITHOUT_XTERM_NEW \
   --with-install-prefix=%{buildroot} --program-transform-name="s,^,,"
make
cd ../widec
ln -s ../configure .
%configure --with-shared --with-cxx --without-ada --with-ospeed=unsigned \
   $WITH_GPM --enable-sigwinch --enable-hard-tabs --enable-xmc-glitch \
   --enable-colorfgbg $WITHOUT_XTERM_NEW --enable-widec \
   --with-install-prefix=%{buildroot} --program-transform-name="s,^,,"
make
cd ..

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_datadir}
mkdir -p %{buildroot}%{_includedir}

cd widec
make install includedir=%{_includedir}/ncurses
mkdir -p %{buildroot}%{includedirw}
mv %{buildroot}%{_includedir}/ncurses/* %{buildroot}%{includedirw}
cd ../narrowc
make install includedir=%{_includedir}/ncurses
cd ..

ln -s %{_datadir}/terminfo/l/linux %{buildroot}%{_datadir}/terminfo/c/console
ln -s %{_includedir}/ncurses/curses.h %{buildroot}%{_includedir}/ncurses.h

for header in curses.h unctrl.h eti.h form.h menu.h panel.h term.h
   do ln -sf ncurses/${header} %{buildroot}%{_includedir}/${header}
done

ln -sf libncurses.a %{buildroot}%{_libdir}/libcurses.a
ln -sf libncursesw.a %{buildroot}%{_libdir}/libcursesw.a

# move lib{n,}curses.so* to /lib/ for zsh
%{__install} -d -m0755 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/lib{n,}curses.so* %{buildroot}/%{_lib}/

%ifarch sparc
install -c -m644 %SOURCE2 %{buildroot}%{_datadir}/terminfo/l/linux
install -c -m644 %SOURCE3 %{buildroot}%{_datadir}/terminfo/l/linux-m
%endif

install -c -m 755 %SOURCE4 %{buildroot}%{_bindir}/resetall

# ncurses should not modify/add system calls
rm -rf %{buildroot}%{_datadir}/man/man2

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README ANNOUNCE doc/html/announce.html
%attr(0755,root,root) /%{_lib}/lib*.so.*
%attr(755,root,root) %{_libdir}/lib*.so.*
%{_datadir}/terminfo
%{_datadir}/tabset
%{_libdir}/lib*.so
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*

%files devel
%defattr(-,root,root)
%doc test
%doc doc/html/hackguide.html
%doc doc/html/ncurses-intro.html
/%{_lib}/lib*.so
%{_libdir}/lib*.a

%dir %{_includedir}/ncurses
%{_includedir}/ncurses/*.h
%{_includedir}/ncursesw/*.h
%{_includedir}/curses.h
%{_includedir}/ncurses.h
%{_includedir}/eti.h
%{_includedir}/form.h
%{_includedir}/menu.h
%{_includedir}/panel.h
%{_includedir}/term.h
%{_includedir}/unctrl.h
%{_mandir}/man3/*

%files c++-devel
%defattr(-,root,root)
%doc c++/NEWS c++/PROBLEMS c++/README*
%{_includedir}/ncurses/cursesapp.h
%{_includedir}/ncurses/curses?.h
%{_includedir}/ncurses/etip.h
%{_libdir}/libncurses++.a

%{_libdir}/libncurses++w.a

%clean
rm -rf %{buildroot}

%ChangeLog
* Mon Mar 28 2005 TAKAHASHI Tamotsu <tamo>
- (5.4-4m)
- update to 5.4-20050327 to fix a minor bug
 introduced in 20050320.

* Sun Mar 27 2005 TAKAHASHI Tamotsu <tamo>
- (5.4-3m)
- update to 5.4-20050326 to fix another widec problem

* Sat Mar 26 2005 TAKAHASHI Tamotsu <tamo>
- (5.4-2m)
- update to 5.4-20050320 to fix widec problems
- re-add terminfo data for jfbterm and kon
 (Shall I remove terminfo.kon?)
- update terminfo.jfbterm to 0.4.7
- remove man2 with wildcard

* Tue Mar  8 2005 Toru Hoshina <t@momonga-linux.org>
- (5.4-1m)
- sync with FC3(5.4-13).

* Wed Sep 29 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (5.3-10m)
- use %%{_lib} instead of lib

* Sat May  1 2004 Toru Hoshina <t@momonga-linux.org>
- (5.3-9m)
- import from FC1 for anaconda.

* Tue Mar 30 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (5.2-23m)
- move libcurses.so to /lib/

* Sun Mar 28 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (5.2-22m)
- move libncurses.so* to /lib/ for zsh

* Thu Mar 25 2004 Toru Hoshina <t@momonga-linux.org>
- (5.2-21m)
- revised spec for rpm 4.2.

* Wed Mar 10 2004 Kimitake SHIBATA <siva@momonga-linux.org>
- (5.2-20m)
- Change BuildRequest coreutils

* Sun Nov  9 2003 Masaru SANUKI <sanuki@hh.iij4u.or.jp>
- (5.2-19m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)
- use %%{momorel}

* Fri Nov 22 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- change ftp site ([Momonga-devel.ja:00825] thanks, TNF) 
  do not bump Release 

* Sat Dec  1 2001 Toru Hoshina <t@kondara.org>
- (5.2-18k)
- No docs could be excutable :-p

* Tue May 22 2001 Toru Hoshina <toru@df-usa.com>
- (5.2-14k)

* Tue May 15 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (5.2-12k)
- added terminfo.kon.alpha for alhpa architecture, because not installation

* Sun May  8 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (5.2-10k)
- modified terminfo.kon same as kterm

* Sun May  6 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (5.2-8k)
- modify terminfo.kon

* Sun May  6 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (5.2-6k)
- add two terminfo files, i.e. jfbterm and kon

* Fri Dec 15 2000 AYUHANA Tomonori <l@kondara.org>
- (5.2-2k)
- backport 5.2-3k for 2.0

* Thu Dec  7 2000 AYUHANA Tomonori <l@kondara.org>
- (5.2-3k)
- version 5.2 (ported from RawHide 5.2-2)
- comment out strip

* Fri Nov 24 2000 Toru Hoshina <toru@df-usa.com>
- use egcs instead of gcc, especially on Alpha :-P

* Tue Nov 14 2000 Tsutomu Yasuda <tom@digitalfactory.co.jp>
- added suppress warning patch

* Wed Jul 05 2000 Toru Hoshina <t@kondara.org>
- rebuild against glibc-2.1.90, X-4.0, rpm-3.0.5.

* Sun Apr 09 2000 Takaaki Tabuchi <tab@kondara.org>
- merge from redhat-6.2 (5.0-11).

* Tue Mar  7 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for sparc baud rates > 38400.

* Fri Feb 18 2000 Preston Brown <pbrown@redhat.com>
- xterm terminfo entries from XFree86 3.3.6
- final round of xterm fixes, follow debian policy.

* Sat Feb  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- strip libraries

* Thu Feb  3 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- More xterm fixes (Bug #9087)

* Thu Jan 27 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- More xterm fixes from Hans de Goede (Bug #8633)

* Sat Jan 15 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- remove some broken symlinks (leftovers from libncurses.so.5)
- Use %configure (Bug #8484)

* Tue Jan 11 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Add xterm patch from Hans de Goede <hans@highrise.nl>
- Patch 20000108, this fixes a problem with a header file.

* Wed Jan  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Add 20000101 patch, hopefully finally fixing the xterm description

* Wed Dec 22 1999 Cristian Gafton <gafton@redhat.com>
- revert to the old major number - because the ABI is not changed (and we
  should be handling the changes via symbol versioning anyway)

* Fri Nov 12 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix a typo in spec
- Add the 19991006 patch, fixing some C++ STL compatibility problems.
- get rid of profiling and debugging versions - we need to save space...

* Thu Nov  4 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- 5.0
- some spec cleanups to make updating easier
- add links *.so.5 to *.so.4 - they are fully binary compatible.
  (Why did they change the invocation number???)

* Wed Sep 22 1999 Cristian Gafton <gafton@redhat.com>
- make clean in the test dir - don't ship any binaries at all.

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- fixed stripping of test programs.

* Sun Aug 29 1999 Preston Brown <pbrown@redhat.com>
- removed 'flash' capability for xterm; see bug #2820 for details.

* Fri Aug 27 1999 Cristian Gafton <gafton@redhat.com>
- add the resetall script from Marc Merlin <marc@merlins.org>

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- added iris-ansi-net as alias for iris-ansi (bug #2561)

* Fri Jul 30 1999 Michael K. Johnson <johnsonm@redhat.com>
- added ncurses-intro.hmtl and hackguide.html to -devel package [bug #3929]

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- make sure ALL binaries are stripped (incl. test binaries)

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- made xterm terminfo stuff MUCH better.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 16)

* Sat Mar 13 1999 Cristian Gafton <gafton@redhat.com>
- fixed header for C++ compiles

* Fri Mar 12 1999 Jeff Johnson <jbj@redhat.com>
- add terminfo entries for linux/linux-m on sparc (obsolete termfile_sparc).

* Thu Feb 18 1999 Cristian Gafton <gafton@redhat.com>
- updated patchset from original site

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- don't build the C++ demo code
- update patch set to the current as of today (redid all the individual
  patches in a single one)

* Wed Oct 14 1998 Cristian Gafton <gafton@redhat.com>
- make sure to strip the binaries

* Wed Sep 23 1998 Cristian Gafton <gafton@redhat.com>
- added another zillion of patches. The spec file *is* ugly
- defattr

* Mon Jul 20 1998 Cristian Gafton <gafton@redhat.com>
- added lots of patches. This spec file is starting to look ugly

* Wed Jul 01 1998 Alan Cox <alan@redhat.com>
- Fix setuid trusting. Open termcap/info files as the real user.

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- added terminfo entry for the poor guys using lat1 and/or lat-2 on their
  consoles... Enjoy linux-lat ! Thanks, Erik !

* Tue Apr 21 1998 Cristian Gafton <gafton@redhat.com>
- new patch to get xterm-color and nxterm terminfo entries
- aliased them to rxvt, as that seems to satisfy everybody

* Sun Apr 12 1998 Cristian Gafton <gafton@redhat.com>
- added %clean section

* Tue Apr 07 1998 Cristian Gafton <gafton@redhat.com>
- removed /usr/lib/terminfo symlink - we shouldn't need that

* Mon Apr 06 1998 Cristian Gafton <gafton@redhat.com>
- updated to 4.2 + patches
- added BuildRoot

* Sat Apr 04 1998 Cristian Gafton <gafton@redhat.com>
- rebuilt with egcs on alpha

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- version 7 didn't rebuild properly on the Alpha somehow -- no real changes
  are in this version

* Tue Dec 09 1997 Erik Troan <ewt@redhat.com>
- TIOCGWINSZ wasn't used properly

* Tue Jul 08 1997 Erik Troan <ewt@redhat.com>
- built against glibc, linked shared libs against -lc

